summaryrefslogtreecommitdiffstats
path: root/nixos/modules
diff options
context:
space:
mode:
authorGraham Christensen <graham@grahamc.com>2020-02-13 11:39:35 -0500
committerGitHub <noreply@github.com>2020-02-13 11:39:35 -0500
commitddd09101c50ff93f47732a66ac6eb1f5084e67c7 (patch)
tree010ad74f76a9c41cedba120f5d305290cd6ba9b3 /nixos/modules
parentc87ec93392e5bc178c384e98bf6fde3336ece60a (diff)
parent2d42fc240c4035e6df5dbbef42a0e3693ede931d (diff)
Merge pull request #79967 from grahamc/nixos-enter-fd2
nixos-enter: redirect to fd2 instead of a file named /dev/stderr
Diffstat (limited to 'nixos/modules')
-rw-r--r--nixos/modules/installer/tools/nixos-enter.sh18
1 files changed, 9 insertions, 9 deletions
diff --git a/nixos/modules/installer/tools/nixos-enter.sh b/nixos/modules/installer/tools/nixos-enter.sh
index 4680cd8ae95a..1fdd4627a902 100644
--- a/nixos/modules/installer/tools/nixos-enter.sh
+++ b/nixos/modules/installer/tools/nixos-enter.sh
@@ -60,15 +60,15 @@ chmod 0755 "$mountPoint/dev" "$mountPoint/sys"
mount --rbind /dev "$mountPoint/dev"
mount --rbind /sys "$mountPoint/sys"
-# If silent, write both stdout and stderr of activation script to /dev/null
-# otherwise, write both streams to stderr of this process
-if [ "$silent" -eq 0 ]; then
- PIPE_TARGET="/dev/stderr"
-else
- PIPE_TARGET="/dev/null"
-fi
+(
+ # If silent, write both stdout and stderr of activation script to /dev/null
+ # otherwise, write both streams to stderr of this process
+ if [ "$silent" -eq 1 ]; then
+ exec 2>/dev/null
+ fi
-# Run the activation script. Set $LOCALE_ARCHIVE to supress some Perl locale warnings.
-LOCALE_ARCHIVE="$system/sw/lib/locale/locale-archive" chroot "$mountPoint" "$system/activate" >>$PIPE_TARGET 2>&1 || true
+ # Run the activation script. Set $LOCALE_ARCHIVE to supress some Perl locale warnings.
+ LOCALE_ARCHIVE="$system/sw/lib/locale/locale-archive" chroot "$mountPoint" "$system/activate" 1>&2 || true
+)
exec chroot "$mountPoint" "${command[@]}"